﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using Microsoft.SharePoint;
namespace TechAmit.SharePoint.LogicalFieldUpdate
{
    public class ConditionParameters
    {

        public static ConditionalTest.TestOptions Parse(ref string parmsToParse)
        {
            // Default seprator is ", "
            return Parse(ref parmsToParse, ", ");
        }

        private static ConditionalTest.TestOptions Parse(ref string parmsToParse, string seprator)
        {
            string[] arParms = parmsToParse.Split(new string[] { seprator }, StringSplitOptions.RemoveEmptyEntries);

            // Default values
            var stringOption = StringComparison.CurrentCultureIgnoreCase;
            var rxOption = RegexOptions.None;

            for (int i = 0; i < arParms.Length; i++)
            {

                switch (arParms[i])
                {
                    case Constants.ConditionParametersTitle.TextCaseSensitive:
                        stringOption = StringComparison.CurrentCulture;
                        break;

                    case Constants.ConditionParametersTitle.RegexCultureInvariant:
                        rxOption = rxOption | RegexOptions.CultureInvariant;
                        break;

                    case Constants.ConditionParametersTitle.RegexEcmaScript:
                        rxOption = rxOption | RegexOptions.ECMAScript;
                        break;

                    case Constants.ConditionParametersTitle.RegexExplicitCapture:
                        rxOption = rxOption | RegexOptions.ExplicitCapture;
                        break;

                    case Constants.ConditionParametersTitle.RegexIgnoreCase:
                        rxOption = rxOption | RegexOptions.IgnoreCase;
                        break;

                    case Constants.ConditionParametersTitle.RegexIgnorePatternWhitepsace:
                        rxOption = rxOption | RegexOptions.IgnorePatternWhitespace;
                        break;

                    case Constants.ConditionParametersTitle.RegexMultiLine:
                        rxOption = rxOption | RegexOptions.Multiline;
                        break;

                    case Constants.ConditionParametersTitle.RegexRightToLeft:
                        rxOption = rxOption | RegexOptions.RightToLeft;
                        break;

                    case Constants.ConditionParametersTitle.RegexSingleLine:
                        rxOption = rxOption | RegexOptions.Singleline;
                        break;

                }
            }

            var testOptions = new ConditionalTest.TestOptions();
            testOptions.StringComparison = stringOption;
            testOptions.RegexOptions = rxOption;

            return testOptions;
        }


    }
}
