﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TechAmit.SharePoint.LogicalFieldUpdate
{
    public static class Constants
    {
        public const string LogicListName = "Logical Field Update";

        public static class LogicListFieldName
        {
            public const string ListName = "List";
            public const string Condition = "Condition";
            public const string ValueType = "Value Type";
            public const string FieldToCompare = "Field To Compare";
            public const string ValueToComapreWith = "Value To Compare With";
            public const string UpdateField = "Update Field";
            public const string CheckNext = "Check Next";
            public const string UpdateWith = "Update With";
            public const string Order = "Order";
            public const string Active = "Active";
            public const string ConditionParameter = "Condition Parameter";
            public const string CheckEvent = "When To Check";
            public const string Validate = "Validate this logic";
        }

        public static class CheckNext
        {
            public const string Always = "Always";
            public const string IfTrue = "If True";
            public const string IfFalse = "If False";
        }

        // List of boolean fields that are used in 
        // list and document library for internal purpose
        // and should be avoided to use in our solution
        public static string[] SystemBooleanFields = 
        {
            "Is Signed",
            "Has Copy Destinations",
            "Is Current Version"
        };

        // Title of events when the logical check should be done
        public static class LogicalCheckEventsTitle
        {
            public const string ItemAdding = "Item being added";
            public const string ItemAdded = "After item added";
            public const string ItemUpdating = "Item being updated";
            public const string ItemUpdated = "After item updated";
        }

        // Condtion parameters
        public static class ConditionParametersTitle
        {
            public const string TextCaseSensitive = "Make Text/String Match Case Sensitive";
            public const string RegexIgnoreCase = "Regex Ignore Case";
            public const string RegexSingleLine = "Regex Single Line";
            public const string RegexMultiLine = "Regex Multiline";
            public const string RegexIgnorePatternWhitepsace = "Regex Ignore Pattern Whitespace";
            public const string RegexRightToLeft = "Regex Right To Left";
            public const string RegexExplicitCapture = "Regex Explicit Capture";
            public const string RegexEcmaScript = "Regex EcmaScript";
            public const string RegexCultureInvariant = "Regex Culture Invariant";
        }

        // Value type
        public static class ConditionValueTypeTitle
        {
            public const string AutoDetect = "Auto Detect";
            public const string String = "String";
            public const string Numeric = "Numeric";
            public const string DateTime = "Date Time";
        }

        // Condition title
        public static class ConditionTitle
        {
                public const string Equal = "Equal";
                public const string NotEqual = "Not Equal";
                public const string Greater = "Greater";
                public const string GreaterOrEqual = "Greater or Equal";
                public const string Lesser = "Lesser";
                public const string LesserOrEqual = "Lesser or Equal";
                public const string StartsWith = "Starts With";
                public const string NotStartsWith = "Not Starts With";
                public const string EndsWith = "Ends With";
                public const string NotEndsWith = "Not Ends With";
                public const string Contains = "Contains";
                public const string NotContains = "Not Contains";
                public const string RegexMatches = "Regex Matches";
                public const string RegexNotMatches = "Regex Not Matches";
                public const string Null =  "Null";
                public const string NotNull =  "Not Null";
                public const string NullOrEmpty = "Null or Empty";
                public const string AnythingButNotNull = "Anything But Not Null";
                public const string AnythingIncludingNull = "Anything Including Null";
        }
    }
}
