﻿using System;
using Microsoft.SharePoint;
namespace TechAmit.SharePoint.LogicalFieldUpdate
{
    class DisabledEventScope : SPItemEventReceiver, IDisposable
    {
        //
        // This code is used from:
        // http://blogs.captechconsulting.com/blog/brandon-atkinson/update-sharepoint-list-item-itemupdated-event-without-endless-loop
        //
        //
        bool _originalValue;

        public DisabledEventScope()
        {
            // Save off the original value of EventFiringEnabled
            _originalValue = base.EventFiringEnabled;

            // Set EventFiringEnabled to false to disable it
            base.EventFiringEnabled = false;
        }

        public void Dispose()
        {
            // Set EventFiringEnabled back to its original value
            base.EventFiringEnabled = _originalValue;
        }
    }
}
