﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using Microsoft.SharePoint;
namespace TechAmit.SharePoint.LogicalFieldUpdate
{
    public static class Utils
    {

        public static bool IsFieldExist(List<string> fieldNameCollToCheck, SPList list)
        {
            bool IsExist = true;

            // Get unique field names
            List<string> uniqueFieldColl = fieldNameCollToCheck.Distinct().ToList();
            foreach (string field in uniqueFieldColl)
            {
                if (list.Fields.ContainsField(field) == false)
                {
                    IsExist = false;
                    break;
                }
            }

            return IsExist;
        }
        public static List<string> GetSquareBracketPlaceHolders(ref string source,bool includeBracket)
        {
            var holders = new List<String>();
            if (string.IsNullOrEmpty(source)) { return holders; }

            // Regex patter that searches for field
            // placeholders (including brackets).
            // Eg: [FieldPlaceHolder]
            string pattern = @"(^\[\S*\])|((?<=[^[])\[[^\[^\]]+\S*?\S+\])";

            // New instance of regurlar expression
            Regex rx = new Regex(pattern);

            // Find placeholders
            var matches = rx.Matches(source);

            // Loop through each place holder
            foreach (Match match in matches)
            {
                if (includeBracket)
                {
                    holders.Add(match.Value);
                }
                else
                {
                    holders.Add(match.Value.Substring(1, match.Value.Length - 2));
                }
            }

            return holders;

        }
        public static List<String> SPMultiChoiceFieldValueToStringList(object value)
        {
            if (value == null) return null;

            var choiceValues = new SPFieldMultiChoiceValue(value.ToString());
            var list = new List<string>();

            for (int i = 0; i < choiceValues.Count; i++)
            {
                list.Add(choiceValues[i]);
            }

            return list;
        }
    }
}
